/*
SQLyog Community v11.52 (64 bit)
MySQL - 5.6.28-log : Database - soft_dev
*********************************************************************
*/


/*!40101 SET NAMES utf8 */;

/*!40101 SET SQL_MODE=''*/;

/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;
CREATE DATABASE /*!32312 IF NOT EXISTS*/`soft_dev` /*!40100 DEFAULT CHARACTER SET utf8 */;

USE `soft_dev`;

/*Table structure for table `bill` */

DROP TABLE IF EXISTS `bill`;

CREATE TABLE `bill` (
  `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `date_created` date DEFAULT NULL,
  `time_created` time DEFAULT NULL,
  `user_created` varchar(100) DEFAULT NULL,
  `amount` decimal(10,0) DEFAULT NULL,
  `company_fk` bigint(20) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `company_fk` (`company_fk`),
  CONSTRAINT `bill_ibfk_1` FOREIGN KEY (`company_fk`) REFERENCES `company` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8;

/*Data for the table `bill` */

/*Table structure for table `bill_items` */

DROP TABLE IF EXISTS `bill_items`;

CREATE TABLE `bill_items` (
  `bill_id` bigint(20) unsigned NOT NULL,
  `item_id` int(20) unsigned NOT NULL,
  `product_fk` varchar(10) DEFAULT NULL,
  `quantity` decimal(10,0) DEFAULT NULL,
  `amount` decimal(10,0) DEFAULT NULL,
  `unit_measure` varchar(3) DEFAULT NULL,
  PRIMARY KEY (`bill_id`,`item_id`),
  KEY `product_fk` (`product_fk`),
  CONSTRAINT `bill_items_ibfk_1` FOREIGN KEY (`product_fk`) REFERENCES `product` (`id`),
  CONSTRAINT `bill_items_ibfk_2` FOREIGN KEY (`bill_id`) REFERENCES `bill` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

/*Data for the table `bill_items` */

/*Table structure for table `city` */

DROP TABLE IF EXISTS `city`;

CREATE TABLE `city` (
  `code` bigint(20) unsigned NOT NULL,
  `name` varchar(100) DEFAULT NULL,
  PRIMARY KEY (`code`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

/*Data for the table `city` */

insert  into `city`(`code`,`name`) values (11000,'Beograd'),(13000,'Pancevo'),(37000,'Krusevac'),(37230,'Aleksandrovac');

/*Table structure for table `company` */

DROP TABLE IF EXISTS `company`;

CREATE TABLE `company` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) DEFAULT NULL,
  `address` varchar(250) DEFAULT NULL,
  `vat` varchar(9) DEFAULT NULL,
  `ident_number` varchar(8) DEFAULT NULL,
  `code_fk` bigint(20) unsigned DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `company_city_fk` (`code_fk`),
  CONSTRAINT `company_city_fk` FOREIGN KEY (`code_fk`) REFERENCES `city` (`code`)
) ENGINE=InnoDB AUTO_INCREMENT=27 DEFAULT CHARSET=utf8;

/*Data for the table `company` */

insert  into `company`(`id`,`name`,`address`,`vat`,`ident_number`,`code_fk`) values (24,'FON','Jove Ilica 154','100383934','07004044',11000),(25,'ETF','Bulevar Kralja Aleksandraа 73','111111111','00000001',11000),(26,'PMF','Stdentski trg 16','100046603','00000000',11000);

/*Table structure for table `product` */

DROP TABLE IF EXISTS `product`;

CREATE TABLE `product` (
  `id` varchar(10) NOT NULL,
  `name` varchar(100) DEFAULT NULL,
  `price` decimal(10,0) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

/*Data for the table `product` */

insert  into `product`(`id`,`name`,`price`) values ('code-1','product-1','100'),('code-2','product-2','181'),('code-3','product-3','351');

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;
