/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package forme.racun.model;

import domen.JedinicaMere;
import domen.Proizvod;
import domen.Racun;
import domen.StavkaRacuna;
import javax.swing.table.AbstractTableModel;

/**
 *
 * @author FON
 */
public class TableModelRacun extends AbstractTableModel{
    private Racun racun;
    String[] naziviKolona={"Proizvod", "Jedinicna cena", "Kolicina", "Jedinica mere", "Iznos"};
    
    public TableModelRacun(Racun racun) {
        this.racun=racun;
    }

    @Override
    public String getColumnName(int column) {
        return naziviKolona[column]; //To change body of generated methods, choose Tools | Templates.
    }

    
    
    @Override
    public int getRowCount() {
        return racun.getStavkaList().size();
    }

    @Override
    public int getColumnCount() {
        return naziviKolona.length;
    }

    @Override
    public Object getValueAt(int rowIndex, int columnIndex) {
        StavkaRacuna sr=racun.getStavkaList().get(rowIndex);
        switch(columnIndex){
            case 0: return sr.getProizvod();
            case 1: 
                if(sr.getProizvod()!=null){
                    return sr.getProizvod().getCena();
                }else{
                    return 0;
                }
            case 2: return sr.getKolicina();
            case 3: return sr.getJedinicaMere();
            case 4: return sr.getIznos();
            default: return "N/A";
        }
    }

    @Override
    public void setValueAt(Object aValue, int rowIndex, int columnIndex) {
        StavkaRacuna sr=racun.getStavkaList().get(rowIndex);
        switch(columnIndex){
            case 0:     
                sr.setProizvod((Proizvod)aValue);
                sr.setIznos(sr.getProizvod().getCena()*sr.getKolicina());
                fireTableCellUpdated(rowIndex, 1);
                fireTableCellUpdated(rowIndex, 4);
                break;
            case 1:
                break;
            case 2:
                sr.setKolicina(Integer.parseInt(aValue.toString()));
                if(sr.getProizvod()!=null){
                    sr.setIznos(sr.getProizvod().getCena()*sr.getKolicina());
                    fireTableCellUpdated(rowIndex, 4);
                }
                break;
            case 3:
                sr.setJedinicaMere(JedinicaMere.valueOf(aValue.toString()));
                break;
            case 4:
                break;
        }
    }

    @Override
    public boolean isCellEditable(int rowIndex, int columnIndex) {
        if(columnIndex==1 || columnIndex==4){
            return false;
        }else{
            return true;
        }
    }

    @Override
    public Class<?> getColumnClass(int columnIndex) {
        if(columnIndex==1){
            return Double.class;
        }else{
            return super.getColumnClass(columnIndex);
        }
    }
    
    public void dodajStavku(){
        racun.dodajStavku();
        fireTableDataChanged();
    }
    
    public void ukloniStavku(int red){
        racun.obrisiStavku(red);
        fireTableDataChanged();
    }
    
}
