/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package so;

import db.DbKomunikacija;

/**
 *
 * @author Korisnik
 */
public abstract class OpstaSO {
    protected Object objekat;
    protected DbKomunikacija dbbr;

    public OpstaSO(Object objekat) {
        this.objekat = objekat;
        this.dbbr = new DbKomunikacija();
    }

    public OpstaSO() {
        this.dbbr = new DbKomunikacija();
    }

    public final void opsteIzvrsenjeSO() throws Exception {
        try {
            ucitajDriver();
            otvoriKonekciju();
        }catch(Exception e){
            throw(e);
        }
        try{
            proveriPreduslov();
            izvrsiOperaciju();
            commitTransakcije();
        } catch (Exception e) {
            rollbackTransakcije();
            throw e;
        } finally {
            zatvoriKonekciju();
        }
    }

    private void ucitajDriver() throws Exception {
        dbbr.ucitajDriver();
    }

    private void otvoriKonekciju() throws Exception {
        dbbr.otvoriKonekciju();
    }

    protected abstract void proveriPreduslov() throws Exception;

    protected abstract void izvrsiOperaciju() throws Exception;

    private void commitTransakcije() throws Exception {
        dbbr.commitTransakcije();
    }

    private void rollbackTransakcije() throws Exception {
        dbbr.rollbackTransakcije();
    }

    private void zatvoriKonekciju() throws Exception {
        dbbr.zatvoriKonekciju();
    }
}
