/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package db;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.LinkedList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import model.Kompanija;
import model.Mesto;
import util.Util;

/**
 *
 * @author FON
 */
public class DatabaseBroker {

    private Connection connection;
    private Util util = new Util();
    
    public void ucitajDriver() throws Exception {
        try {
            Class.forName(util.getValue("driver"));
            System.out.println("Uspesno ucitan driver!");
        } catch (ClassNotFoundException ex) {
            throw new Exception("Greska prilikom ucitavanja drivera!\n" + ex);
        }
    }

    public void uspostaviKonekciju() throws Exception {
        String url = util.getValue("url");
        String user = util.getValue("user");
        String password = util.getValue("password");
        try {
            connection = DriverManager.getConnection(url, user, password);
            connection.setAutoCommit(false); // Zahteva se eksplicitna potvrda transakcije
            System.out.println("Uspesno uspostavljena konekcija nad bazom!");
        } catch (SQLException ex) {
            throw new Exception("Greska prilikom uspostavljanja konekcije nad bazom!\n" + ex);
        }
    }

    public void raskiniKonekciju() throws Exception {
        try {
            connection.close();
            System.out.println("Uspesno raskinuta konekcija!");
        } catch (SQLException ex) {
            throw new Exception("Greska prilikom raskidanja konekcije!\n" + ex);
        }
    }
    
    public void commitTransakcije() throws Exception {
        try {
            connection.commit();
        } catch (SQLException ex) {
            throw new Exception("Greska prilikom commita transakcije!\n" + ex);
        }
    }

    public void rollbackTransakcije() throws Exception {
        try {
            connection.rollback();
        } catch (SQLException ex) {
            throw new Exception("Greska prilikom rollbacka transakcije!\n" + ex);
        }
    }

    public void insertMesto(Mesto mesto) throws Exception {
        String upit = "INSERT INTO Mesto (pttBroj, naziv) VALUES (" + mesto.getPttBroj() + ", '" + mesto.getNaziv() + "')";
        try {
            Statement statement = connection.createStatement();
            statement.executeUpdate(upit);
            System.out.println("Uspesno ubaceno Mesto!");
        } catch (SQLException ex) {
            throw new Exception("Greska prilikom ubacivanja mesta!\n" + ex);
        }
    }

    public List<Mesto> vratiMesta() throws Exception {
        try {
            List<Mesto> lm = new LinkedList<>();
            String sql = "SELECT * FROM Mesto";
            Statement sqlStatement = connection.createStatement();
            ResultSet rs = sqlStatement.executeQuery(sql);
            while (rs.next()) {
                int pttBroj = rs.getInt("pttBroj");
                String naziv = rs.getString(2);
                Mesto m = new Mesto(pttBroj, naziv);
                lm.add(m);
            }
            return lm;
        } catch (SQLException ex) {
            throw new Exception("Greska prilikom ucitavanja mesta!\n" + ex);
        }
    }

    public void insertKompanija(Kompanija k) throws Exception {
        try {
            // String sql = "INSERT INTO Kompanija(naziv, maticniBroj, ulica, broj, mesto) VALUES ('" + k.getNaziv() + "','" + k.getMaticniBroj() + "','" + k.getUlica() + "','" + k.getBroj() + "'," + k.getMesto().getPttBroj() + ")";
            String sql = "INSERT INTO Kompanija(naziv, maticniBroj, ulica, broj, mesto) VALUES (?,?,?,?,?)";
            PreparedStatement sqlStatement = connection.prepareStatement(sql, Statement.RETURN_GENERATED_KEYS);
            sqlStatement.setString(1, k.getNaziv());
            sqlStatement.setString(2, k.getMaticniBroj());
            sqlStatement.setString(3, k.getUlica());
            sqlStatement.setString(4, k.getBroj());
            sqlStatement.setInt(5, k.getMesto().getPttBroj());
            sqlStatement.executeUpdate();
            ResultSet rs = sqlStatement.getGeneratedKeys();
            if (rs.next()) {
                int kompanijaID = rs.getInt(1);
                System.out.println("KompanijaID: " + kompanijaID);
                k.setKompanijaID(kompanijaID);
            } else {
                throw new Exception("Greska prilikom generisanja PK!");
            }
        } catch (SQLException ex) {
            throw new Exception("Greska prilikom cuvanja kompanije!\n" + ex);
        }
    }

}
