/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package komunikacija;

import domen.Kompanija;
import domen.OpstiDomenskiObjekat;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.Socket;
import java.util.List;
import kontroler.Kontroler;
import transfer.Operacija;
import transfer.TransferObjekatOdgovor;
import transfer.TransferObjekatZahtev;

/**
 *
 * @author FON
 */
public class NitKlijent extends Thread {

    private Socket socket;
    private boolean aktivan;

    public NitKlijent(Socket socket) {
        this.socket = socket;
        this.aktivan = true;
    }

    @Override
    public void run() {
        try {
            izvrsenjeOperacija();
        } catch (IOException | ClassNotFoundException ex) {
            aktivan = false;
        }
        System.out.println("NitKlijent - kraj rada.");
    }

    private void izvrsenjeOperacija() throws IOException, ClassNotFoundException {
        while (aktivan) {
            ObjectInputStream inSocket = new ObjectInputStream(socket.getInputStream());
            TransferObjekatZahtev toZahtev = (TransferObjekatZahtev) inSocket.readObject();
            TransferObjekatOdgovor toOdgovor = new TransferObjekatOdgovor();
            System.out.println("Operacija: " + toZahtev.getOperacija());
            try {
                switch (toZahtev.getOperacija()) {
                    case Operacija.VRATI_MESTA:
                        List<OpstiDomenskiObjekat> lm = Kontroler.getInstance().vratiMesta();
                        toOdgovor.setRezultat(lm);
                        break;
                    case Operacija.VRATI_KOMPANIJE:
                        List<Kompanija> lk = Kontroler.getInstance().vratiKompanije();
                        toOdgovor.setRezultat(lk);
                        break;
                    case Operacija.SACUVAJ_KOMPANIJU:
                        Kompanija k = (Kompanija) toZahtev.getParametar();
                        Kontroler.getInstance().sacuvajKompaniju(k);
                        toOdgovor.setPoruka("OK");
                        break;
                }
            } catch (Exception ex) {
                ex.printStackTrace();
                toOdgovor.setIzuzetak(ex);
                toOdgovor.setPoruka(ex.getMessage());
            }
            posalji(toOdgovor);
        }
    }

    private void posalji(TransferObjekatOdgovor toOdgovor) throws IOException {
        ObjectOutputStream outSocket = new ObjectOutputStream(socket.getOutputStream());
        outSocket.writeObject(toOdgovor);
    }

}
