/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package rs.ac.bg.fon.silab.gui.example1.components.table.model;

import javax.swing.table.AbstractTableModel;
import rs.ac.bg.fon.silab.jdbc.example1.domen.BillItemlEntity;
import rs.ac.bg.fon.silab.jdbc.example1.domen.BillEntity;
import rs.ac.bg.fon.silab.jdbc.example1.domen.ProductEntity;

/**
 *
 * @author FON
 */
public class BillTableModel extends AbstractTableModel {

    private final BillEntity bill;
    private String[] columnNames = new String[]{"Item Id", "Product", "Amount", "Quantity", "Measure"};

    public BillTableModel(BillEntity bill) {
        this.bill = bill;
    }

    @Override
    public boolean isCellEditable(int rowIndex, int columnIndex) {
//        if(columnIndex == 1 || columnIndex == 3 || columnIndex == 4){
//            return true;
//        }
//        return false;
        
        return (columnIndex == 1 || columnIndex == 3 || columnIndex == 4);
    }

    @Override
    public String getColumnName(int column) {
        return columnNames[column];
    }

    @Override
    public int getRowCount() {
        return bill.getItems().size();
    }

    @Override
    public int getColumnCount() {
        return 5;
    }

    @Override
    public Object getValueAt(int rowIndex, int columnIndex) {
        BillItemlEntity billItem = bill.getItems().get(rowIndex);

        switch (columnIndex) {
            case 0:
                return billItem.getItemId();
            case 1:
                return billItem.getProductEntity() != null ? billItem.getProductEntity().getName() : "-";
            case 2:
                return billItem.getAmount();
            case 3:
                return billItem.getQuantity();
            case 4:
                return billItem.getUnitMeasure() != null ? billItem.getUnitMeasure().toString() : "-";
            default:
                return "N/A";
        }
    }

    @Override
    public void setValueAt(Object aValue, int rowIndex, int columnIndex) {
        BillItemlEntity billItem = bill.getItems().get(rowIndex);
        
        switch(columnIndex){
            case 1:
                ProductEntity product = (ProductEntity)aValue;
                billItem.setProductEntity(product);
                break;
            case 3:
                billItem.setQuantity(Double.parseDouble(aValue.toString()));
                break;
            case 4:
                // Ovde mora biti string koji predstavlja mernu jedinicu
                break;
        }
    }
    
    public void addNewBillItem() {
        BillItemlEntity billItem = new BillItemlEntity();
        billItem.setItemId(bill.getItems().size() + 1);

        bill.getItems().add(billItem);
        fireTableDataChanged();
    }
}
