/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package dbbr;

import domen.Kompanija;
import domen.Mesto;
import domen.Proizvod;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author FON
 */
public class DBBroker {

    
    Connection konekcija;
    
    private static DBBroker instanca;
    
    public static DBBroker vratiInstancu(){
        
        if (instanca==null){
            instanca = new DBBroker();
        }
        
        return instanca;
    }
    
    private DBBroker() {
        
    }
    
    
    public void uspostaviKonekciju() throws SQLException{
        
        String urlBaze = "jdbc:mysql://localhost:3306/prosoftd1"; 
        String user = "root"; 
        String pass = "root";
        
        konekcija = DriverManager.getConnection(urlBaze,user,pass);
        konekcija.setAutoCommit(false);
        System.out.println("USPESNA KONEKCIJA!");       
        
    }
    
    public void zatvoriKonekciju() throws SQLException {
        
        if (!konekcija.isClosed()){
            konekcija.close();
        }
        
    }
    
    public void potvrdiTransakciju() throws SQLException{
        konekcija.commit();
    }
    
    public void ponistiTransakciju() throws SQLException{
        konekcija.rollback();
    }
    
    public List<Mesto> vratiSvaMesta() throws SQLException{
        
        List<Mesto> listaMesta = new ArrayList<>();
        
        String upit = "Select * FROM Mesto";
        
        Statement naredba = konekcija.createStatement();
        
        ResultSet rsMesta = naredba.executeQuery(upit);
        
        while(rsMesta.next()){
            
            Mesto m = new Mesto();
            
            m.setPtt(rsMesta.getInt("ptt"));
            m.setNaziv(rsMesta.getString("naziv"));
            
            listaMesta.add(m);
        }
        
        
        return listaMesta;
    }
    
    public List<Proizvod> vratiSveProizvode() throws SQLException{
        
        List<Proizvod> listaProizvoda = new ArrayList<>();
        
        String upit = "Select * FROM Proizvod";
        
        Statement naredba = konekcija.createStatement();
        
        ResultSet rsProizvod = naredba.executeQuery(upit);
        
        while(rsProizvod.next()){
            
            Proizvod p = new Proizvod();
            
            p.setProizvodID(rsProizvod.getInt("proizvodID"));
            p.setNaziv(rsProizvod.getString("naziv"));
            p.setCena(rsProizvod.getDouble("trenutnaCena"));
            
            listaProizvoda.add(p);
        }
        
        
        return listaProizvoda;
    }
    
    
    
    public List<Kompanija> vratiSveKompanije() throws SQLException{
        
        List<Kompanija> listaKompanija = new ArrayList();
        
        String upit = "Select k.*, m.naziv as nazivMesta FROM Kompanija k INNER JOIN Mesto m on k.mesto = m.ptt";
        
        Statement naredba = konekcija.createStatement();
        
        ResultSet rsKompanija = naredba.executeQuery(upit);
        
        while(rsKompanija.next()){
            
            Kompanija kompanija = new Kompanija();
            
            
            kompanija.setKompanijaID(rsKompanija.getInt("kompanijaID"));
            kompanija.setMaticniBroj(rsKompanija.getString("maticniBroj"));
            kompanija.setNaziv(rsKompanija.getString("naziv"));
            //// ???   MESTO ?????
            int ptt = rsKompanija.getInt("mesto");
            String nazivMesta = rsKompanija.getString("nazivMesta");
            
            Mesto m = new Mesto(ptt, nazivMesta);
            kompanija.setMesto(m);
            // II Nacin
            //kompanija.setMesto(vratiMestoPoPtt(ptt));
            listaKompanija.add(kompanija);
        }
        return listaKompanija;
    }
    
     public Mesto vratiMestoPoPtt(int ptt) throws SQLException{
        
        Mesto m = null;
        
        String upit = "Select * FROM Mesto WHERE ptt = "+ptt;        
        Statement naredba = konekcija.createStatement();
        
        ResultSet rsMesta = naredba.executeQuery(upit);
        
        if (rsMesta.next()){
            
            m = new Mesto();            
            m.setPtt(rsMesta.getInt("ptt"));
            m.setNaziv(rsMesta.getString("naziv"));
        }
        
        
        return m;
    }
    
     
     public void sacuvajKompaniju(Kompanija k) throws SQLException{
            
        String upit = "INSERT INTO KOMPANIJA (maticniBroj,naziv,mesto) VALUES (?,?,?)";       
        
        PreparedStatement pripremljenaNaredba = konekcija.prepareStatement(upit);
        
        pripremljenaNaredba.setString(1, k.getMaticniBroj());
        pripremljenaNaredba.setString(2, k.getNaziv());
        pripremljenaNaredba.setInt(3, k.getMesto().getPtt());
        
        
        pripremljenaNaredba.executeUpdate();
        
    }
    
    
}
