/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package forme.modeltabele;

import domen.Proizvod;
import domen.Racun;
import domen.StavkaRacuna;
import javax.swing.table.AbstractTableModel;

/**
 *
 * @author FON
 */
public class ModelTabeleStavkaRacuna extends AbstractTableModel {
    
    Racun racun;

    public ModelTabeleStavkaRacuna(Racun racun) {
        this.racun = racun;
    }
    
    
    String naziviKolona [] ={"Rb","Proizvod","Kolicina","Cena","Iznos"}; 
    

    @Override
    public int getRowCount() {
        return racun.getStavkeRacuna().size();
    }

    @Override
    public int getColumnCount() {
        return naziviKolona.length;
    }

    @Override
    public String getColumnName(int column) {
        return naziviKolona[column];
    }

    @Override
    public boolean isCellEditable(int rowIndex, int columnIndex) {
        if (columnIndex==0 || columnIndex==4) return false;
        
        return true; //To change body of generated methods, choose Tools | Templates.
    }
    
    

    @Override
    public Object getValueAt(int rowIndex, int columnIndex) {
        
        StavkaRacuna stavka = racun.getStavkeRacuna().get(rowIndex);
        
        switch (columnIndex){
            
            case 0: return stavka.getRb();
            
            case 1: return stavka.getProizvod();
            
            case 2: return stavka.getKolicina();
            
            case 3: return stavka.getCena();
            
            case 4: return stavka.getIznos();
            
            default: return "N/A";            
        }        
    }
    
    
    public void dodajStavku(){
        StavkaRacuna novaStavka = new StavkaRacuna();
        
        novaStavka.setRacun(racun);
        novaStavka.setRb(racun.getStavkeRacuna().size()+1);
        
        racun.getStavkeRacuna().add(novaStavka);
        fireTableRowsInserted(racun.getStavkeRacuna().size()-1, racun.getStavkeRacuna().size()-1);
        
    }

    
    Class tipoviKolona[] = {Integer.class,Proizvod.class,Double.class,Double.class,Double.class};
    
    @Override
    public Class<?> getColumnClass(int columnIndex) {
        
        return tipoviKolona[columnIndex];
    }
    
    
    
    

    @Override
    public void setValueAt(Object aValue, int rowIndex, int columnIndex) {
        
        StavkaRacuna stavka = racun.getStavkeRacuna().get(rowIndex);
        
        switch(columnIndex){
            
            case 0: stavka.setRb((Integer) aValue);
            break;
            
            case 1: stavka.setProizvod((Proizvod) aValue);
            stavka.setCena(((Proizvod)aValue).getCena());
            stavka.setIznos(stavka.getCena()*stavka.getKolicina());
            break;
            
            case 2: stavka.setKolicina((double) aValue);
            stavka.setIznos(stavka.getCena()*stavka.getKolicina());
            break;
            
            case 3: stavka.setCena((double) aValue);
            break;
            
            
            
        }
        
        fireTableRowsUpdated(rowIndex, rowIndex);
        
    }
    
    
    
    
}
