/*
SQLyog Community v12.09 (64 bit)
MySQL - 5.6.16 : Database - prosoftd1
*********************************************************************
*/


/*!40101 SET NAMES utf8 */;

/*!40101 SET SQL_MODE=''*/;

/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;
CREATE DATABASE /*!32312 IF NOT EXISTS*/`prosoftd1` /*!40100 DEFAULT CHARACTER SET utf8 */;

USE `prosoftd1`;

/*Table structure for table `Proizvod` */

DROP TABLE IF EXISTS `Proizvod`;

CREATE TABLE `Proizvod` (
  `proizvodID` int(11) NOT NULL AUTO_INCREMENT,
  `naziv` varchar(30) NOT NULL,
  `trenutnaCena` float DEFAULT '0',
  PRIMARY KEY (`proizvodID`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8;

/*Data for the table `Proizvod` */

insert  into `Proizvod`(`proizvodID`,`naziv`,`trenutnaCena`) values (1,'Cokolada 100g',100),(2,'Cokolada Milka 300g',340),(3,'Hleb Sava ',50);

/*Table structure for table `Racun` */

DROP TABLE IF EXISTS `Racun`;

CREATE TABLE `Racun` (
  `Broj` int(11) NOT NULL,
  `datumIVreme` datetime DEFAULT NULL,
  `kompanija` int(11) DEFAULT NULL,
  PRIMARY KEY (`Broj`),
  KEY `fk_racun_kompanija` (`kompanija`),
  CONSTRAINT `fk_racun_kompanija` FOREIGN KEY (`kompanija`) REFERENCES `kompanija` (`kompanijaID`) ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

/*Data for the table `Racun` */

insert  into `Racun`(`Broj`,`datumIVreme`,`kompanija`) values (1,NULL,1);

/*Table structure for table `StavkaRacuna` */

DROP TABLE IF EXISTS `StavkaRacuna`;

CREATE TABLE `StavkaRacuna` (
  `Broj` int(11) NOT NULL,
  `rb` int(11) NOT NULL,
  `proizvod` int(11) DEFAULT NULL,
  `cena` double DEFAULT NULL,
  `kolicina` double DEFAULT NULL,
  `iznos` double DEFAULT NULL,
  PRIMARY KEY (`Broj`,`rb`),
  KEY `fk_stavka_proizov` (`proizvod`),
  CONSTRAINT `fk_stavka_proizov` FOREIGN KEY (`proizvod`) REFERENCES `Proizvod` (`proizvodID`) ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

/*Data for the table `StavkaRacuna` */

insert  into `StavkaRacuna`(`Broj`,`rb`,`proizvod`,`cena`,`kolicina`,`iznos`) values (1,1,1,10,10,100);

/*Table structure for table `kompanija` */

DROP TABLE IF EXISTS `kompanija`;

CREATE TABLE `kompanija` (
  `maticniBroj` varchar(9) DEFAULT NULL,
  `kompanijaID` int(11) NOT NULL AUTO_INCREMENT,
  `naziv` varchar(30) DEFAULT NULL,
  `mesto` int(11) DEFAULT NULL,
  PRIMARY KEY (`kompanijaID`),
  KEY `fk_kompanija_mesto` (`mesto`),
  CONSTRAINT `fk_kompanija_mesto` FOREIGN KEY (`mesto`) REFERENCES `mesto` (`ptt`) ON UPDATE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;

/*Data for the table `kompanija` */

insert  into `kompanija`(`maticniBroj`,`kompanijaID`,`naziv`,`mesto`) values ('M87984654',1,'FON',11000);

/*Table structure for table `mesto` */

DROP TABLE IF EXISTS `mesto`;

CREATE TABLE `mesto` (
  `ptt` int(11) NOT NULL,
  `naziv` varchar(30) DEFAULT NULL,
  PRIMARY KEY (`ptt`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

/*Data for the table `mesto` */

insert  into `mesto`(`ptt`,`naziv`) values (11000,'Beograd'),(21000,'Novi sad');

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;
