/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package logic;

import db.DatabaseBroker;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import model.Kompanija;
import model.Mesto;

/**
 *
 * @author FON
 */
public class Kontroler {
    private DatabaseBroker dbbr;
    private static Kontroler instance;
    
    public static Kontroler getInstance(){
        if(instance==null){
            instance=new Kontroler();
        }
        return instance;
    }
    
    private Kontroler(){
        dbbr=new DatabaseBroker();
        try {
            dbbr.ucitajDriver();
        } catch (Exception ex) {
            throw new RuntimeException(ex.getMessage());
        }
    }
    
    
    public List<Mesto> vratiSvaMesta() throws Exception{
        List<Mesto> mesta=null;
        try {
            dbbr.uspostaviKonekciju();
        }catch(Exception ex){
            throw ex;
        }
        
        try {
            mesta=dbbr.vratiMesta();
            dbbr.commitTransakcije();
        } catch (Exception ex) {
            dbbr.rollbackTransakcije();
            throw ex;
        }finally{
            dbbr.raskiniKonekciju();
        }
        return mesta;
    }
    
    public void kreirajKompaniju(Kompanija kompanija) throws Exception{

        try {
            dbbr.uspostaviKonekciju();
        }catch(Exception ex){
            throw ex;
        }
        
        try {
            dbbr.insertKompanija(kompanija);
            dbbr.commitTransakcije();
        } catch (Exception ex) {
            dbbr.rollbackTransakcije();
            throw ex;
        }finally{
            dbbr.raskiniKonekciju();
        }
    }
}
