/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package komunikacija;

import domen.Kompanija;
import domen.Mesto;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.List;
import kontroler.Kontroler;
import transfer.Operacije;
import transfer.TransferObjekatOdgovor;
import transfer.TransferObjekatZahtev;

/**
 *
 * @author FON
 */
public class Komunikacija {
    private boolean aktivan=true;
    
    public void pokreniServer() throws IOException, ClassNotFoundException{
        ServerSocket ss=new ServerSocket(9000);
        System.out.println("Server je pokrenut i ceka klijenta!");
        Socket s=ss.accept();
        System.out.println("Klijent se povezao!");
        izvrsenjeOperacija(s);
    }
    
    private void izvrsenjeOperacija(Socket s) throws IOException, ClassNotFoundException{
        while(aktivan){
            ObjectInputStream in=new ObjectInputStream(s.getInputStream());
            TransferObjekatZahtev toZahtev=(TransferObjekatZahtev)in.readObject();
            TransferObjekatOdgovor toOdgovor=new TransferObjekatOdgovor();
            System.out.println("Operacija ["+toZahtev.getOperacija()+"]");
            try{
                switch(toZahtev.getOperacija()){
                    case Operacije.VRATI_MESTA:
                        List<Mesto> listaMesta=Kontroler.getInstance().vratiMesta();
                        toOdgovor.setRezultat(listaMesta);
                        break;
                    case Operacije.SACUVAJ_KOMPANIJU:
                        Kompanija k=(Kompanija)toZahtev.getParametar();
                        Kontroler.getInstance().sacuvajKompaniju(k);
                        toOdgovor.setRezultat(k);
                        break;
                }
            }catch(Exception e){
                toOdgovor.setIzuzetak(e);
                toOdgovor.setPoruka(e.getMessage());
                e.printStackTrace();
            }
            posaljiOdgovor(toOdgovor, s);
        }
    }
    
    private void posaljiOdgovor(TransferObjekatOdgovor toOdgovor, Socket s) throws IOException{
        ObjectOutputStream out=new ObjectOutputStream(s.getOutputStream());
        out.writeObject(toOdgovor);
    }
    
    public static void main(String[] args) throws IOException, ClassNotFoundException {
        Komunikacija k=new Komunikacija();
        k.pokreniServer();
    }
}
