/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package server;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import rs.ac.bg.fon.silab.jdbc.example1.db.DatabaseRepository;
import rs.ac.bg.fon.silab.jdbc.example1.domen.CityEntity;
import rs.ac.bg.fon.silab.jdbc.example1.domen.CompanyEntity;
import transfer.request.RequestObject;
import transfer.response.ResponseObject;
import transfer.util.IOperation;
import transfer.util.IStatus;

/**
 *
 * @author FON
 */
public class Server {

    public void start() {
        try {
            ServerSocket serverSocket = new ServerSocket(9009);
            System.out.println("Waiting for client");
            Socket socket = serverSocket.accept();
            System.out.println("Client connected");
            startCommunication(socket);
        } catch (Exception ex) {
            Logger.getLogger(Server.class.getName()).log(Level.SEVERE, null, ex);
        }

    }

    private void startCommunication(Socket socket) throws Exception {
        while (true) {
            //prihvati zahtev od klijenta
            ObjectInputStream input = new ObjectInputStream(socket.getInputStream());
            RequestObject request = (RequestObject) input.readObject();
            //obradi zahtev
            ResponseObject responseObject = new ResponseObject();
            switch (request.getOperation()) {
                case IOperation.GET_ALL_CITIES:
                    try {
                        List<CityEntity> cities = new DatabaseRepository().getAllCity();
                        responseObject.setCode(IStatus.OK);
                        responseObject.setData(cities);
                    } catch (Exception e) {
                        responseObject.setCode(IStatus.ERROR);
                        responseObject.setMessage(e.getMessage());
                    }

                    break;
                case IOperation.SAVE_COMPANY:
                    CompanyEntity company = (CompanyEntity) request.getData();
                    try {
                        company = new DatabaseRepository().saveCompany(company);
                        responseObject.setCode(IStatus.OK);
                        responseObject.setData(company);
                    } catch (Exception e) {
                        responseObject.setCode(IStatus.ERROR);
                        responseObject.setMessage(e.getMessage());
                    }

                    break;

            }

            //fill response object
            ObjectOutputStream output = new ObjectOutputStream(socket.getOutputStream());
            output.writeObject(responseObject);
            output.flush();
        }
    }

}
