/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package rs.ac.bg.fon.silab.server.thread;

import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.Socket;
import java.util.List;
import rs.ac.bg.fon.silab.jdbc.example1.db.DatabaseRepository;
import rs.ac.bg.fon.silab.jdbc.example1.domen.CityEntity;
import rs.ac.bg.fon.silab.jdbc.example1.domen.CompanyEntity;
import rs.ac.bg.fon.silab.server.so.AbstractGenericOperation;
import rs.ac.bg.fon.silab.server.so.SaveCompany;
import transfer.request.RequestObject;
import transfer.response.ResponseObject;
import transfer.util.IOperation;
import transfer.util.IStatus;

/**
 *
 * @author FON
 */
public class ThreadClient extends Thread {

    Socket socket;

    public ThreadClient(Socket socket) {
        this.socket = socket;
    }

    @Override
    public void run() {
        while (!isInterrupted()) {
            try {
                //prihvati zahtev od klijenta
                ObjectInputStream input = new ObjectInputStream(socket.getInputStream());
                RequestObject request = (RequestObject) input.readObject();
                //obradi zahtev
                ResponseObject responseObject = new ResponseObject();
                switch (request.getOperation()) {
                    case IOperation.GET_ALL_CITIES:
                        try {
                            List<CityEntity> cities = new DatabaseRepository().getAllCity();
                            responseObject.setCode(IStatus.OK);
                            responseObject.setData(cities);
                        } catch (Exception e) {
                            responseObject.setCode(IStatus.ERROR);
                            responseObject.setMessage(e.getMessage());
                        }

                        break;
                    case IOperation.SAVE_COMPANY:
                        CompanyEntity company = (CompanyEntity) request.getData();
                        try {
                            //company = new DatabaseRepository().saveCompany(company);
                            AbstractGenericOperation saveCompany = new SaveCompany();
                            saveCompany.templateExecute(company);
                            //company mora da sadrzi ID!
                            responseObject.setCode(IStatus.OK);
                            responseObject.setData(company);
                        } catch (Exception e) {
                            responseObject.setCode(IStatus.ERROR);
                            responseObject.setMessage(e.getMessage());
                        }

                        break;

                }

                //fill response object
                ObjectOutputStream output = new ObjectOutputStream(socket.getOutputStream());
                output.writeObject(responseObject);
                output.flush();
            } catch (Exception e) {
                e.printStackTrace();
            }

        }
    }

}
