/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package rs.ac.bg.fon.silab.gui.example1.components.table.model;

import java.util.List;
import javax.swing.table.AbstractTableModel;
import rs.ac.bg.fon.silab.jdbc.example1.domen.BillEntity;
import rs.ac.bg.fon.silab.jdbc.example1.domen.BillItemsEntity;
import rs.ac.bg.fon.silab.jdbc.example1.domen.CompanyEntity;
import rs.ac.bg.fon.silab.jdbc.example1.domen.ProductEntity;

/**
 *
 * @author FON
 */
public class BillTableModel extends AbstractTableModel {

    private final BillEntity bill;
    private String [] columnNames = new String[]{"Item","Product","Quantity","Amount","Measure"};

    public BillTableModel(BillEntity bill) {
        this.bill = bill;
    }

    @Override
    public int getRowCount() {
        if(bill == null || bill.getItems() == null) {
            return 0;
        }
        return bill.getItems().size();
    }

    @Override
    public int getColumnCount() {
        return columnNames.length;
    }

    @Override
    public Object getValueAt(int rowIndex, int columnIndex) {
        BillItemsEntity item = bill.getItems().get(rowIndex);
        switch (columnIndex) {
            case 0:
                return item.getItemId();
            case 1:
                return item.getProductEntity().getName();
            case 2:
                return item.getQuantity();
            case 3:
                return item.getAmount();
            case 4:
                return item.getUnitMeasure();
            default:
                return "N/A";
        }
    }

    @Override
    public String getColumnName(int column) {
        return columnNames[column];
    }

    public void addRow() {
        BillItemsEntity billItem = new BillItemsEntity();
        billItem.setItemId(bill.getItems().size() + 1);
        
        bill.getItems().add(billItem);
        fireTableDataChanged();
    }

    @Override
    public boolean isCellEditable(int rowIndex, int columnIndex) {
        return (columnIndex == 1 || columnIndex == 2);
    }

    @Override
    public void setValueAt(Object value, int rowIndex, int columnIndex) {
        BillItemsEntity billItem = bill.getItems().get(rowIndex);
        
        if(columnIndex == 1) {
            ProductEntity product = (ProductEntity) value;
            billItem.setProductEntity(product);
        }
        if(columnIndex == 2) {
            billItem.setQuantity(Double.parseDouble(value.toString()));
        }
    }

    
}
