/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package rs.ac.bg.fon.silab.gui.example1.components.table.model;

import java.util.List;
import javax.swing.table.AbstractTableModel;
import rs.ac.bg.fon.silab.jdbc.example1.domen.BillItemlEntity;
import rs.ac.bg.fon.silab.jdbc.example1.domen.BillEntity;
import rs.ac.bg.fon.silab.jdbc.example1.domen.ProductEntity;

/**
 *
 * @author FON
 */
public class BillTableModel extends AbstractTableModel {

    private final BillEntity bill;
    private String[] columnNames = new String[]{"Item Id", "Product", "Amount", "Quantity", "Measure"};

    public BillTableModel(BillEntity bill) {
        this.bill = bill;
    }

    @Override
    public boolean isCellEditable(int rowIndex, int columnIndex) {
//        if(columnIndex == 1 || columnIndex == 3 || columnIndex == 4){
//            return true;
//        }
//        return false;

        return (columnIndex == 1 || columnIndex == 3 || columnIndex == 4);
    }

    @Override
    public String getColumnName(int column) {
        return columnNames[column];
    }

    @Override
    public int getRowCount() {
        return bill.getItems().size();
    }

    @Override
    public int getColumnCount() {
        return 5;
    }

    @Override
    public Object getValueAt(int rowIndex, int columnIndex) {
        BillItemlEntity billItem = bill.getItems().get(rowIndex);

        switch (columnIndex) {
            case 0:
                return billItem.getItemId();
            case 1:
                return billItem.getProductEntity() != null ? billItem.getProductEntity().getName() : "-";
            case 2:
                return billItem.getAmount();
            case 3:
                return billItem.getQuantity();
            case 4:
                return billItem.getUnitMeasure() != null ? billItem.getUnitMeasure().toString() : "-";
            default:
                return "N/A";
        }
    }

    @Override
    public void setValueAt(Object aValue, int rowIndex, int columnIndex) {
        BillItemlEntity billItem = bill.getItems().get(rowIndex);

        switch (columnIndex) {
            case 1:
                ProductEntity product = (ProductEntity) aValue;
                billItem.setProductEntity(product);
                setAmount(billItem);
                break;
            case 3:
                billItem.setQuantity(Double.parseDouble(aValue.toString()));
                setAmount(billItem);
                break;
            case 4:
                // Ovde mora biti string koji predstavlja mernu jedinicu
                break;
        }
    }

    public void addNewBillItem() {
        List<BillItemlEntity> billItems = bill.getItems();
        if (billItems.isEmpty() || 
                billItems.get(billItems.size() - 1).getProductEntity() != null) {
            BillItemlEntity billItem = new BillItemlEntity();
            billItem.setItemId(bill.getItems().size() + 1);

            bill.getItems().add(billItem);
            updateBillAmount();
            fireTableDataChanged();
        }
    }

    private void setAmount(BillItemlEntity billItem) {
        if (billItem.getProductEntity() != null && billItem.getQuantity() > 0) {
            billItem.setAmount(billItem.getProductEntity().getPrice() * billItem.getQuantity());
            fireTableDataChanged();
        }
    }

    public void removeItem(int selectedItem) {
        if (bill != null && selectedItem >= 0 && selectedItem < bill.getItems().size()) {
            bill.getItems().remove(selectedItem);
            updateBillItems();
            updateBillAmount();
            fireTableDataChanged();
        }
    }

    private void updateBillItems() {
        List<BillItemlEntity> billItems = bill.getItems();
        int size = billItems.size();
        for (int i = 0; i < size; i++) {
            billItems.get(i).setItemId(i + 1);
        }
    }

    private void updateBillAmount() {
        List<BillItemlEntity> billItems = bill.getItems();
        double currentAmount = 0.0;
        
        for (BillItemlEntity billItem : billItems) {
            if (billItem.getProductEntity() != null) {
                currentAmount += 
                    billItem.getProductEntity().getPrice() * billItem.getQuantity();
            }
        }
        
        bill.setAmount(currentAmount);
    }

    public double getCurrentBillAmount() {
        return bill.getAmount();
    }

    public BillEntity getBill() {
        return bill;
    }
}
