/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package rs.ac.bg.fon.silab.jdbc.example1.db;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import rs.ac.bg.fon.silab.jdbc.example1.domen.CityEntity;
import rs.ac.bg.fon.silab.jdbc.example1.domen.CompanyEntity;

/**
 *
 * @author FON
 */
public class DatabaseRepository {

    public void saveCity(Long ptt, String name) throws Exception {

        Connection connection = DatabaseConnection.getInstance().getConnection();

        StringBuilder sb = new StringBuilder();
        sb.append("INSERT INTO city VALUES")
                .append("(")
                .append(ptt)
                .append(",")
                .append("'")
                .append(name)
                .append("'")
                .append(")");

        String query = sb.toString();
        System.out.println(query);

        Statement statement = connection.createStatement();
        statement.executeUpdate(query);
        statement.close();

    }

    public CityEntity findCityByPTT(Long ptt) throws Exception {
        Connection connection = DatabaseConnection.getInstance().getConnection();
        String query = "SELECT * FROM city WHERE ptt=?";
        PreparedStatement ps = connection.prepareStatement(query);
        ps.setLong(1, ptt);
        ResultSet rs = ps.executeQuery();
        if (rs.next()) {
            Long cityPtt = rs.getLong("ptt");
            String name = rs.getString("name");
            CityEntity city = new CityEntity(cityPtt, name);
            rs.close();
            ps.close();

            return city;
        }
        throw new Exception("Grad sa ovim ptt-om ne postoji!");
    }

    public CompanyEntity findCompanyByID(Long id) throws Exception {
        Connection connection = DatabaseConnection.getInstance().getConnection();
        String query = "SELECT * FROM company WHERE id=?";
        PreparedStatement ps = connection.prepareStatement(query);
        ps.setLong(1, id);
        ResultSet rs = ps.executeQuery();
        if (rs.next()) {
            Long companyId = rs.getLong("id");
            String name = rs.getString("name");
            String address = rs.getString("address");
            String vat = rs.getString("vat");
            String identNumber = rs.getString("ident_number");
            Long ptt = rs.getLong("ptt_fk");
            CityEntity city = findCityByPTT(ptt);
            CompanyEntity company = new CompanyEntity(companyId, name, address, vat, identNumber, city);
            rs.close();
            ps.close();
            return company;
        }
        throw new Exception("Kompanija sa ovim id-jem ne postoji!");
    }

    public CompanyEntity saveCompany(CompanyEntity company) throws Exception {
        Connection connection = DatabaseConnection.getInstance().getConnection();

        String query = "INSERT INTO company(name,address,vat,ident_number,ptt_fk) VALUES (?,?,?,?,?)";
        PreparedStatement ps = connection.prepareStatement(query, Statement.RETURN_GENERATED_KEYS);

        ps.setString(1, company.getName());
        ps.setString(2, company.getAddress());
        ps.setString(3, company.getVat());
        ps.setString(4, company.getIdentNumber());
        ps.setLong(5, company.getCity().getPtt());

        ps.executeUpdate();
        ResultSet rs = ps.getGeneratedKeys();
        if (rs.next()) {
            Long companyID = rs.getLong(1);
            System.out.println("Nova kompanija ima ID: " + companyID);
            ps.close();

            return findCompanyByID(companyID);
        }
        throw new Exception("Greska kod generisanja kljuca!");

    }
    
    public CompanyEntity findCompanyByIDInnerJoin(Long id) throws Exception {
        Connection connection = DatabaseConnection.getInstance().getConnection();
        String query = "SELECT company.id,company.name,company.address,company.vat,company.ident_number,city.ptt,city.name AS city FROM company INNER JOIN city ON company.ptt_fk=city.ptt WHERE company.id=?";
        PreparedStatement ps = connection.prepareStatement(query);
        ps.setLong(1, id);
        ResultSet rs = ps.executeQuery();
        if (rs.next()) {
            Long companyId = rs.getLong("id");
            String name = rs.getString("name");
            String address = rs.getString("address");
            String vat = rs.getString("vat");
            String identNumber = rs.getString("ident_number");
            Long ptt = rs.getLong("ptt");
            String cityName = rs.getString("city");
            CityEntity city = new CityEntity(ptt, cityName);
            CompanyEntity company = new CompanyEntity(companyId, name, address, vat, identNumber, city);
            rs.close();
            ps.close();
            return company;
        }
        throw new Exception("Kompanija sa ovim id-jem ne postoji!");
    }
}
